// 仕様：カソードコモン
int ANODEPIN[10] = { 11, 10, 9, 8, 7, 6, 5, 4, 3, 2 };
int CATHODEPIN[3] = { 14, 16, 15 };	// R, G, B

void setup()
{
	// アノードを、LOWで初期化
	for( int ano = 0; ano < 10; ano++ )
	{
		pinMode( ANODEPIN[ano], OUTPUT );
		digitalWrite( ANODEPIN[ano], LOW );
	}

	// カソードを、HIGHで初期化
	for( int cat = 0; cat < 3; cat++ )
	{
		pinMode( CATHODEPIN[cat], OUTPUT );
		digitalWrite( CATHODEPIN[cat], HIGH );
	}
}

double array[10][3] = { { 1.0,  0.0,  0.0 },	// 赤
						{ 0.0,  1.0,  0.0 },	// 緑
						{ 0.0,  0.0,  1.0 },	// 青
						{ 1.0,  1.0,  0.0 },	// 黄
						{ 0.0,  1.0,  1.0 },	// 水色
						{ 1.0,  0.0,  1.0 },	// ピンク
						{ 0.25, 0.25, 0.0 },	// 黄土色
						{ 0.0,  0.25, 0.25 },	// 紺
						{ 0.25, 0.0,  0.25 },	// 紫
						{ 1.0,  1.0,  1.0 } };	// 白

// 仕様：各色4階調
void lightRGB( int anodepin, int rpin, int gpin, int bpin, double r, double g, double b )
{
	int iR4 = (int)(r * 4.0 + 0.5);
	int iG4 = (int)(g * 4.0 + 0.5);
	int iB4 = (int)(b * 4.0 + 0.5);
	digitalWrite( anodepin, HIGH );	// HIGHに変更
	for( int i = 0; i < 10; i++ )
	{
		for( int j = 0; j < 4; j++ )
		{
			digitalWrite( rpin, !(j < iR4) );
			digitalWrite( gpin, !(j < iG4) );
			digitalWrite( bpin, !(j < iB4) );
		}
	}
	digitalWrite( rpin, HIGH );	// HIGHに戻す
	digitalWrite( gpin, HIGH );	// HIGHに戻す
	digitalWrite( bpin, HIGH );	// HIGHに戻す
	digitalWrite( anodepin, LOW );	// LOWに戻す
}

void loop()
{
	// アノードのループ
	for( int ano = 0; ano < 10; ano++ )
	{
		lightRGB( ANODEPIN[ano], CATHODEPIN[0], CATHODEPIN[1], CATHODEPIN[2], array[ano][0], array[ano][1], array[ano][2] );
	}
}

